<template>
	<!--弹窗-->
	<div class="yidialog-con" id="Dia">
		<div class="yid-con flex-row yid-con-col">
			<!-- 弹窗内容	-->
			<div class="course-bag-alert">
				<div class="cancle-btn"></div>
				<div class="get-btn"></div>
                <p class="send-num"></p>
			</div>
			<!--  引导分享弹窗	-->
			<div class="course-bag-guide-share">
				<p class="tip">分享后打开链接拆红包</p>
				<p class="content bag-index">第一个拆红包</p>
				<p class="content">必得14天免费看</p>
			</div>
		</div>
	</div>
	<div id="courseBagFloat" class="course-bag-float">
		<img class="img" src="http://static2.61info.com/service/imgs/groupPurchase/course_share_bag/float.png" alt="">
	</div>
</template>

<script>
	export default {
		data: {
			pageName: $('body').data('page-name'), // inviteFriends  collageDetails
			courseId: +utils.getQueryString('courseId'),
			shareMap: [
				{
					version: 'a',
					channel: '160200086',
					title: '我只有10个名额！随机得大额红包，更有机会得拼图、免费课！',
					desc: '500万家长都在给孩子看的课程，再不看就亏了！点击马上领>>'
				},
				// {
				// 	version: 'b',
				// 	channel: '160200087',
				// 	title: '第{num}个拿大奖！随机得3-8元红包，更有机会爆出拼图、免费课！', // X为该红包的随机第X位可得14天免费看的字数
				// 	desc: '500万家长都在给孩子看的课程，再不看就亏了！点击马上领>>'
				// },
				{
					version: 'c',
					channel: '160200088',
					title: '第{num}个领取的红包最大，有机会免费获得99元给孩子的动画课！',
					desc: '500万家长都在给孩子看的课程，再不看就亏了！点击马上领>>'
				}
			]
		},
		// pvuvkey
		pvuvKeyMap: {
			ALERT_EXPOSURE: 1442,
			ALERT_CLICK: 1441,
			FLOAT_EXPOSURE: 1444,
			FLOAT_CLICK: 1443
		},
		// 初始化
		init: function () {
			var _this = this;

			var isSuperActBeing = new Date() > new Date('2020/04/25 00:00:00') && new Date() < new Date('2020/05/03 23:59:59');
			if (isSuperActBeing) return
			_this.request.entry({courseId: _this.data.courseId}, function (res) {
				if (res.resultCode.code == 0) {
					var resData = res.value;
					// 未关注
					if (!resData.sub) {
						return
					}
					// 没有红包，或者红包失效
					if (!resData.packet) {
						return
					}
					_this.initEntry(resData)
				}
			})

		},
		//
		initEntry: function (resData) {
			var _this = this;
			var storageKey = 'course_bag_' + _this.data.courseId;
			if (localStorage.getItem(storageKey)) {
				initFloat();
			}
			initAlert();

			function initAlert() {
				// 优化红包
				if (utils.getQueryString('needRedBag') === 'true') {
					// 模板消息点击进入直接弹起蒙层吊起分享
					initAlertEven();
					$('.course-bag-alert').hide();
					setTimeout(function () {
						$('.get-btn').trigger('click');
					})
					initFloat();
				}
				// /优化红包
				var isCreateGroup = resData.leader; // leader为false时，表示单购或参团
				if (localStorage.getItem(storageKey)) return // 已弹过，不弹
				/** 开团与参团区分 */
				if (isCreateGroup) { // 开团，分享之后才显示
					$('body').on('courseBagShareSucc', function () {
                        var storageKey = 'course_bag_' + _this.data.courseId;
                        if (localStorage.getItem(storageKey)) return // 已弹过，不弹
						initAlertEven();
						initFloat();
					})
					return
				} else { // 参团,直接显示
					initAlertEven();
					initFloat();
				}

				// 显示弹窗及绑定事件
				function initAlertEven() {
					_this.popupAlert.show('course-bag-alert');
                    $('.send-num').html('已累计发出'+ resData.free +'次免费看');
					_this.request.addPvuv(_this.pvuvKeyMap.ALERT_EXPOSURE);
					var $alert = _this.popupAlert.get$Dia('course-bag-alert');
					var $Dia = _this.popupAlert.get$Dia();
					$alert.find('.cancle-btn').on('click', function () {
						_this.popupAlert.hide();
					})
					$alert.on('click', function (e) {
						e.stopPropagation();
					})
					$Dia.find('.yid-con-col').on('click', function () {
						_this.popupAlert.hide();
					})
					$alert.find('.get-btn').on('click', function () {
						_this.request.addPvuv(_this.pvuvKeyMap.ALERT_CLICK, function () {
							toAct();
						});
					})

					localStorage.setItem(storageKey, storageKey);
				}
			}

			function initFloat() {
				var $float = $(courseBagFloat)
				$('body').append($float);
				_this.request.addPvuv(_this.pvuvKeyMap.FLOAT_EXPOSURE);

				$float.on('click', function () {
					_this.request.addPvuv(_this.pvuvKeyMap.FLOAT_CLICK, function () {
						toAct('float');
					})
				})
			}

			function toAct(type) {
				_this.request.getShareInfo({isIndex: true, packetId: resData.packetId}, function (res) {
					if (res.resultCode.code === 0) {
						$('.course-bag-alert').hide();
						$('.course-bag-guide-share').show();
						var shareData = {};
						shareData = {
							x: res.value.x,
							packetId: resData.packetId
						};
						shareData.main = _this.data.shareMap[Math.floor(Math.random() * _this.data.shareMap.length)];
						shareData.main.title = shareData.main.title.replace('{num}', shareData.x);
                        if (type === 'float') {
                            _this.popupAlert.show('course-bag-alert');
                            $('.course-bag-alert').hide();
                            $('.course-bag-guide-share').show();
                            $('body').on('click', '.yidialog-con', function () {
                            	$(this).hide();
							})
                        }
						$('.course-bag-guide-share .bag-index').html('第'+ shareData.x +'个开红包');
						$('body').trigger('courseBagShare', shareData);
					}
				})
				// location.href = window.window.actIndependentDomain + '/app/spa/dengta_h5/share_bag?pageType=index&packetId=' + resData.packetId
			}
		},
		/**
		 * 曝光统计
		 */
		scrollExposure: function ($elem, callback, $childElem) {
			if (!$elem) return
			var isInviewAndExposure = false;
			if (utils.isInView($elem, $childElem)) {
				// 统计曝光
				callback && callback();
				isInviewAndExposure = true;
			}
			document.addEventListener('scroll', utils.throttle(function () {
				var isEleInView = utils.isInView($elem, $childElem);
				if (isEleInView && !isInviewAndExposure) {
					// 统计曝光
					callback && callback();
					isInviewAndExposure = true
				}
				if (!isEleInView) {
					isInviewAndExposure = false;
				}
			}, 300));
		},
		/**
		 * 弹窗控制器
		 */
		popupAlert: (function () {
			var $Dia = $(Dia);
			$Dia.find('.yid-cls-con').children().hide(); // 刚开始隐藏所有弹窗内容的显示
			var hadInsertBody = false; // 弹窗是否插入body中
			var curType = ''; // 当前弹窗

			function checkHide () {
				// 显示弹窗之前，检查其他弹窗是否关闭
				if (curType) {
					$Dia.hide();
				}
			}

			return {
				getCurType: function () {
					return curType
				},
				/**
				 * 获取弹窗对象
				 * @param className
				 * @returns {*}
				 */
				get$Dia: function (className) {
					return className ? $Dia.find('.' + className) : $Dia;
				},
				/**
				 * 隐藏弹窗
				 * @param callback
				 * @returns {*|jQuery.fn.init|jQuery|HTMLElement}
				 */
				hide: function (callback) {
					$Dia.find('.' + curType).hide();
					$Dia.hide();
					callback && callback();
					return $Dia;
				},
				/**
				 * 显示弹窗
				 * @param className 弹窗的class名称
				 * @param callback
				 * @returns {*|jQuery.fn.init|jQuery|HTMLElement}
				 */
				show: function (className, callback) {
					if (!className) return
					checkHide();
					curType = className;
					$Dia.find('.' + className).show();
					hadInsertBody ? $Dia.show() : ($('body').append($Dia) && (hadInsertBody = true));
					callback && callback();
					return $Dia;
				}
			}
		})(),
		// 禁止滑动
		isForbidScroll: (function () {
			var isForbidScroll = utils.forbidScroll();
			return function (isForbid) {
				isForbidScroll(isForbid)
			}
		})(),
		// 请求
		request: (function () {
			var _request = function (url, data, callback, async) {
				$.ajax({
					url: url,
					data: data,
					async: async,
					success: function (res) {
						callback && callback(res);
					},
					fail: function () {
						ui61.toast('网络异常');
					}
				})
			};

			var actId = '10046';

			return {
				// 获取入口信息
				entry: function (data, callback) {
					_request('/dengta/act/course/redpacket/entry.json', data, callback, true)
				},
				/** pvuv统计 */
				addPvuv: function (pvuvKeyId, callback) {
					_request('/dengta/common/act/' + actId + '/addPvuv.json', {pvuvKeyId: pvuvKeyId}, callback, true)
				},
				getShareInfo: function (data, callback) {
					_request('/dengta/act/course/redpacket/page.json', data, callback, true)
				}
			}
		})()
	}
</script>

<style scoped lang="less">
	@BASE_IMG_URL: 'http://test.static2.61info.cn/service/imgs/groupPurchase/course_share_bag';

	.course-bag-alert {
		position: relative;
		width: 682px;
		height: 893px;
		left: 16px;
		background: url('@{BASE_IMG_URL}/bag_alert_new.png') no-repeat center / 100%;
		.cancle-btn, .get-btn {
			position: absolute;
			bottom: 56px;
			width: 256px;
			height: 98px;
			&.cancle-btn {
				width: 40px;
				height: 40px;
				left: 300px;
				bottom: -100px;
				background: url('@{BASE_IMG_URL}/bag_alert_close_icon.png') no-repeat center / 100%;
			}
			&.get-btn {
				width: 493px;
				height: 130px;
				left: 80px;
				bottom: 90px;
			}
		}
        .send-num{
            position: absolute;
            bottom: 50px;
            left: 50%;
            transform: translateX(-50%);
            text-align: center;
            font-size: 28px;
            color: #faecdf;
        }
	}

	.course-bag-guide-share{
		position: absolute;
		display: none;
		top: .5rem;
		width: 528px;
		height: 343px;
		background: url('@{BASE_IMG_URL}/bag_alert_guide_share.png') no-repeat center / 100%;
		.tip{
			margin: 165px 0 25px;
			text-align: center;
			font-size: 28px;
			color: #ffefcc;
		}
		.content{
			margin-bottom: .1rem;
			color: #ffefcc;
			text-align: center;
			font-weight: bold;
			font-size: 38px;
		}
	}

	.course-bag-float {
		position: fixed;
		top: 50%;
		right: 39px;
		width: 175px;
		height: 153px;
		.img {
			width: 100%;
			height: 100%;
		}
	}

	.flex-row {
		display: -moz-box;
		/* 老版本语法: Firefox (buggy) */
		display: -ms-flexbox;
		/* 混合版本语法: IE 10 */
		display: -webkit-flex;
		/* 新版本语法: Chrome 21+ */
		display: flex;
	}

	@cl-mask: rgba(0, 0, 0, 0.85);
	/**弹窗**/
	.yidialog-con {
		position: fixed;
		width: 100%;
		height: 100%;
		top: 0px;
		left: 0px;
		display: flex;
		align-items: center;
		justify-content: center;
		z-index: 1000;
		background: @cl-mask;

		.yid-back {
			position: absolute;
			left: 0px;
			top: 0px;
			width: 100%;
			height: 100%;
			text-align: center;
			background: @cl-mask;
		}

		.yid-con {
			position: relative;
			display: flex;
			justify-content: center;
			align-content: center;
			color: #ffffff;
			flex-wrap: wrap;

			.yid-cls {
				position: relative;
				z-index: 9999;
				width: 0.51rem;
				height: 0.51rem;
				flex-shrink: 0;
			}

			.yid-hand {
				position: absolute;
				width: 1rem;
				top: 3.1rem;
				right: 0.1rem;
				animation: handClick 1s infinite;
			}
		}

		.yid-con-col {
			display: flex;
			justify-content: center;
			align-items: center;
			width: 100%;
			height: 100%;
		}
	}

	/**toast**/
	.yid-toast-con {
		display: none;

		.yid-back {
			opacity: 0;
		}

		.yid-con {
			.yid-con-body {
				justify-content: center;
				align-items: center;

				.msg {
					padding: 20px;
					background-color: #333333;
					color: #ffffff;
					font-size: 28px;
					border-radius: 10px;
				}
			}
		}
	}

	.my-hand-ani {
		animation: myHandAni 1s infinite;
	}

	@keyframes myHandAni {
		50% {
			left: 80px;
		}
		0%, 100% {
			left: 50px;
		}
	}

	@keyframes iconClick {
		0%, 100% {
			margin-bottotm: 0;
		}
		50% {
			margin-bottom: -35px;
			transform: scale(1.1);
		}
	}

	@keyframes handClick {
		from {
			margin-top: 0rem;
			margin-right: 0rem;
		}
		50% {
			margin-top: -0.1rem;
			margin-right: 0.1rem;
			transform: scale(0.9);
		}
		to {
			margin-top: -0rem;
			margin-right: 0rem;
		}
	}

	.scale-size {
		animation: scaleSize 2s infinite;
	}

	@keyframes scaleSize {
		from {
			transform: scale(0.9);
			opacity: 0.9;
		}
		50% {
			transform: scale(1.2);
			opacity: 1;
		}
		to {
			transform: scale(0.9);
			opacity: 0.9;
		}
	}

	.heart-beat {
		animation: heartBeat 1s infinite;
	}

	@keyframes heartBeat {
		0% {
			-webkit-transform: scale(1);
			transform: scale(1);
		}

		14% {
			-webkit-transform: scale(.8);
			transform: scale(.8);
		}

		28% {
			-webkit-transform: scale(1);
			transform: scale(1);
		}

		42% {
			-webkit-transform: scale(.8);
			transform: scale(.8);
		}

		70% {
			-webkit-transform: scale(1);
			transform: scale(1);
		}
	}

	/**淡入*/
	.fade-in {
		animation: fadeIn 1s;
	}

	@keyframes fadeIn {
		from {
			opacity: 0;
		}
		to {
			opacity: 1;
		}
	}
</style>
